unit Pageform;

interface

{   
This program example shows how to save resources using a notebook.
Thanks to 3k Computer Consultancy for useful hints.

Comments are welcome, E-Mail me!

Use this software as freeware. The only thing I ask you is that
if you find any bugs, please E-Mail me!

David Obber, MC8783@mclink.it

------------------------------------------------------------------                            
							DISCLAIMER
------------------------------------------------------------------                            
Use this software at your own risk. I won't be held responsible for 
anything that goes wrong.

}

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TPageForm = class(TForm)
  private
	{ Private declarations }
  protected
	WinCtrl: TWinControl;
	procedure CreateParams(var Params: TCreateParams); override;

	{ Protected declarations }
  public
	constructor Create(AOwner: TComponent); override;
	{ Public declarations }
  published
	{ Published declarations }
  end;

procedure Register;

implementation

procedure TPageForm.CreateParams(var Params: TCreateParams);
begin
	inherited CreateParams(Params);

	{ If the WinControl parent is defined, then the Parent of the form becomes
	the Owner of the Control, the handle of the parent window is the handle of
	the control (usually a notebook) }
	if WinCtrl <> NIL then
		with Params do
		begin
		Parent := TWinControl(WinCtrl.Owner);
		WndParent := WinCtrl.Handle;
		Style := WS_CHILD OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN;
		Align := alClient;
		end;

end;


constructor TPageForm.Create(AOwner: TComponent);
begin
	{ if the owner is a TWinControl, get the Owner from it }
	if (AOwner is TWinControl) and not (AOwner is TForm) then
		begin
		WinCtrl := TWinControl(AOwner);
		inherited Create(WinCtrl.Owner);
		end
	else { nothing happens, it's a normal form }
		begin
		WinCtrl := NIL;
		inherited Create(AOwner);
		end;
end;


procedure Register;
begin
	RegisterComponents('Samples', [TPageForm]);
end;

end.
